<?php

// $Id: clsDB.php 7 2010-10-20 19:08:19Z scott_auge $

include_once ("clsConfig.php");

class clsDB extends clsConfig {

  public $Connection;
	
  public function __construct () {
	
	  parent::__construct();
	
	  $this->Connection = new mysqli ($this->Host, $this->User, $this->Password, $this->Database);
		
		if ($this->Connection->connect_error) {
      die('Connect Error (' . $mysqli->connect_errno . ') ' . $mysqli->connect_error);
    }
		
	} // constructor
	
	//
	// Often used for setting the time zone or other client parameters 
	//
	
	public function ExecSQL ($SQL) {
	
	  $S = $this->Connection->prepare($SQL);
		$S->execute();
		$S->close();
	
	}
	
	public function ExecQuery ($SQL) {
	
	  $S = $this->Connection->query($SQL);
		$D = $S->fetch_assoc();
		$S->close();	
	  
		return $D;
		
	}
	
	// Used for returning array of objects from a bound parameter select
	// MySQLi checked.  May not work with other DB drivers
	
  protected function ResultToObjects($stmt)
    {
      $result = array();
     
      $metadata = $stmt->result_metadata();
      $fields = $metadata->fetch_fields();

      for (;;)
      {
        $pointers = array();
        $row = new stdClass();
       
        $pointers[] = $stmt;
        foreach ($fields as $field)
        {
          $fieldname = $field->name;
          $pointers[] = &$row->$fieldname;
        }
       
        call_user_func_array(mysqli_stmt_bind_result, $pointers);
       
        if (!$stmt->fetch())
          break;
       
        $result[] = $row;
      }
     
      $metadata->free();
     
      return $result;
    } 	
	
} // class
?>