<?php

// $Id: clsPriority.php 7 2010-10-20 19:08:19Z scott_auge $

//
//  Used to help parse the Priority sysval.
//


include_once ("clsSysvals.php");

class clsPriority {

  public $DB;
	private $PriorityByName;
	private $PriorityByNumber;
	
  public function __construct ($DB) {
	
	  $this->DB = $DB;
		$this->ReadSysVal();
		
	} // constructor
	
	private function ReadSysVal() {
	
	  $S = new clsSysvals($this->DB);
		$S->FindByTitle("TicketPriority");
	
		$Entries = explode("\n", $S->sysval_value);
		foreach($Entries as $Entry) {
		
		  $NVP = explode ("|", $Entry);
			$this->PriorityByName[$NVP[1]] = $NVP[0];
			$this->PriorityByNumber[$NVP[0]] = $NVP[1];
			
		} // foreach
		
	} // ReadSysVal ()
	
	public function NumberToName ($Number) {
	
	  return $this->PriorityByNumber[$Number];
	
	} // NumberToName()
	
	public function NameToNumber ($Name) {
	
	  return $this->PriorityByName[$Name];
	
	} // NameToNumber()
	
} // clsPriority




/* UNIT TEST CODE 

include_once ("clsDB.php");

echo "Unit Test<br>";
$S = new clsPriority(new clsDB());
echo $S->NumberToName("0")  . "<br>";
echo $S->NameToNumber("Normal")  . "<br>";



 */
?>