<?php

include_once ("clsUser.php");
include_once ("clsSession.php");

class clsSecurity extends clsUtil {

    public $SessionID;
    public $DB;
    public $Data;

    public function __construct ($SessionID, $DB) {

      $this->DB = $DB;
      $this->Data = array();

      if ($SessionID != "")
        $this->SessionID = $SessionID;
      else
        $this->GenerateSessionID();
        
    } // __construct()

    public function GenerateSessionID () {

        $this->SessionID = self::RandomString(40);  // Match pri-key on sessions table
        return $this->SessionID;
        
    } // GenerateSessionID

    public function GetSessionData () {

      $Session = new clsSession($this->DB);
      $Session->FindByID($this->SessionID);
      $this->Data = unserialize($Session->session_data);

    } // GetSessionData

    public function SaveSessionData () {

      $Session = new clsSession($this->DB);
      $Session->FindByID($this->SessionID);
      $Session->session_data = serialize ($this->Data);
      $Session->Update();

    } // SaveSessionData

    public function PerformLogin ($UserLogin, $UserPassword) {

      $User = new clsUser($this->DB);
      $User->FindByLoginPassword($UserLogin, $UserPassword);
      if ($User->user_id == "") return false;

      $this->Data["user_userlogin"] = $UserLogin;
      $this->Data["user_id"] = $User->user_id;
      $this->Data["user_company"] = $User->user_company;
      
      $Session = new clsSession($this->DB);
      $Session->Create($this->SessionID);
      $Session->session_data = serialize ($this->Data);
      $Session->session_user = $User->user_id;
      $Session->Update();

      return true;

    } // PerformLogin

    public function CanLogin ($UserLogin, $UserPassword) {

      $User = new clsUser($this->DB);
      $User->FindByLoginPassword($UserLogin, $UserPassword);
      if ($User->user_id != "") return true;
      return false;

    } // CanLogin

    public function IsLoggedIn () {

      $Session = new clsSession($this->DB);
      $Session->FindByID($this->SessionID);
      $this->Data = unserialize($Session->session_data);
      if ($this->Data["user_id"] == "")
        return false;
      else
        return true;

    } // IsLoggedIn

    public function PerformLogout () {

      $Session = new clsSession($this->DB);
      $Session->FindByID($this->SessionID);
      $Session->Delete();

    } // PerformLogout

}
?>