<?php
//
// Generated by tools/TableClass.php
// $Id: clsUser.php 14 2010-10-21 02:41:41Z scott_auge $
//

include_once ("clsUtil.php");

class clsUser extends clsUtil {

  // Database object (usually clsDB.php)

  public $DB;

  // Database fields

    public $user_id;
    public $user_contact;
    public $user_username;
    public $user_password;
    public $user_parent;
    public $user_type;
    public $user_company;
    public $user_department;
    public $user_owner;
    public $user_signature;

  public function __construct ($DB) {

    $this->DB = $DB;

  } // Constructor

  public function Create () {


        // if an auto incrementing key field, then we need to use last_insert_id() to get the value
    // last_insert_id() is mysql oriented.  See curval() for postgresql

    $SQL = "INSERT INTO users () VALUES ()";
    $S = $this->DB->Connection->prepare($SQL);
    $S->execute();

    $SQL = "SELECT LAST_INSERT_ID();";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_result($ID);
    $S->execute();
    $S->fetch();

    $S->close();

        $this->user_id = $ID;

  } // Create ()

  public function Delete () {

    $SQL = "DELETE FROM users WHERE user_id = ?";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("s", $this->user_id);
    $S->execute();
    $S->close();

  } // Delete ()


  public function Update () {

    //
    // We are using parameterized SQL, there is no need for magic quotes on this stuff.
    // If any of it is on, then we want to remove slashes from the input because it comes
    // back out with the slashes.
    //

    if (get_magic_quotes_gpc() || ini_get("magic_quotes_runtime")) {

      $this->user_id = stripslashes($this->user_id);
      $this->user_contact = stripslashes($this->user_contact);
      $this->user_username = stripslashes($this->user_username);
      $this->user_password = stripslashes($this->user_password);
      $this->user_parent = stripslashes($this->user_parent);
      $this->user_type = stripslashes($this->user_type);
      $this->user_company = stripslashes($this->user_company);
      $this->user_department = stripslashes($this->user_department);
      $this->user_owner = stripslashes($this->user_owner);
      $this->user_signature = stripslashes($this->user_signature);

    } // if magic used


    //
    //  Warning!  Generator doesn't handle blob fields very well.  You may need to do some
    //            hand coding with MySQLi's Stmt->send_long_data() to properly update.  If
    //            the blob exceeds MYSQLs packet size (the DB, not PHP) then corruption is
    //            guaranteed.
    //            Use
    //                mysql> SHOW VARIABLES LIKE 'max_allowed_packet';
    //            to determine the size of data you're set up for.
    //


    $SQL = "UPDATE users SET user_contact = ?,user_username = ?,user_password = MD5(?),user_parent = ?,user_type = ?,user_company = ?,user_department = ?,user_owner = ?,user_signature = ? WHERE user_id = ?";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("issiiiiiss", $this->user_contact,$this->user_username,$this->user_password,$this->user_parent,$this->user_type,$this->user_company,$this->user_department,$this->user_owner,$this->user_signature,$this->user_id);
    $S->execute();
    $S->close();

  } // Update ()


  public function FindByID ($ID) {

    $SQL = "SELECT user_id,user_contact,user_username,user_password,user_parent,user_type,user_company,user_department,user_owner,user_signature FROM users WHERE user_id = ?";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("s", $ID);

    // This order is very important for dealing with BLOBs and other large data types

    $S->execute();
    $S->store_result();
    $S->bind_result($this->user_id,$this->user_contact,$this->user_username,$this->user_password,$this->user_parent,$this->user_type,$this->user_company,$this->user_department,$this->user_owner,$this->user_signature);

    $S->fetch();
    $S->close();

  } // FindByID ()

 // --------------------- Begin non-generated coding -----------------

 public function FindByLoginPassword ($UserLogin, $UserPassword) {

   $SQL = "SELECT user_id FROM users where user_username = ? AND user_password = MD5(?)";
		 $S = $this->DB->Connection->prepare($SQL);
		 $S->bind_param("ss", $UserLogin, $UserPassword);
   $S->execute();
   $S->store_result();
   $S->bind_result($ID);
   $S->fetch();
   $S->close();

   $this->FindByID($ID);

 } // FindByLoginPassword

} // class


?>