<?php

//
// Ability to create Sysvals specific to a user.
// We do this because we don't want to mess with the user_preferences table.
// We simply make a value of [user_id].[SysValName] in sysvals.sysval_title.
// $Id: clsUserSysval.php 19 2010-10-21 02:57:42Z scott_auge $
//


include_once("clsSysvals.php");

class clsUserSysval {

  public $user_id;
  public $SysVal;

  public function __construct($DB, $UserID) {

    $this->SysVal = new clsSysvals($DB);
    $this->user_id = $UserID;

  } // constructor

  public function Create () {

    $this->SysVal->Create();

  } // Create

  public function Delete () {

    $this->SysVal->Delete();

  } // Delete

  public function Update () {

    $this->SysVal->Update();

  } // Update()

  public function Available () {

    return $this->SysVal->Available();

  } // Available

  //
  // The following are tools to automatically append the user_id
  // to the title of the parameter, else the programmer must do this!
  //

  public function FindByTitle ($Title) {

    $this->SysVal->FindByTitle("UserSetting." . $this->user_id . "." . $Title);
    
  } // FindByTitle ()

  public function SetValue($Title, $Value) {

    $this->SysVal->sysval_title = "UserSetting." . $this->user_id . "." . $Title;
    $this->SysVal->sysval_value = $Value;

  } // SetValue()

} // class


/* UNIT TEST 

include_once ("clsDB.php");

$S = new clsUserSysval(new clsDB(), "2");
$S->FindByTitle("ShowStatus");
if ( ! $S->Available() ) $S->Create();
$S->SetValue("ShowStatus", "0,1");
$S->Update();
//echo $S->FindByTitle("ShowStatus");
*/
?>
