<?php

// $Id: clsHTMLWidgets.php 7 2010-10-20 19:08:19Z scott_auge $

include_once ("clsProjects.php");
include_once ("clsUser.php");
include_once ("clsSysvals.php");

class clsHTMLWidgets {

  public $DB;
  public $user_id;

  public function __construct ($DB) {

    $this->DB = $DB;

  } // constructor

  public function ProjectsSelection ($WidgetName, $SelectedValue) {

    $User = new clsUser($this->DB);
    $User->FindByID($this->user_id);

    $Project = new clsProjects($this->DB);

    if ($User->user_company == 0) {

      $SQL = "SELECT project_id FROM projects";
      $S = $this->DB->Connection->prepare($SQL);

    } else {

      $SQL = "SELECT project_id FROM projects WHERE project_company = ?";
      $S = $this->DB->Connection->prepare($SQL);
      $S->bind_param ("s", $User->user_company);

    } // else

    $S->execute();
    $S->store_result();
    $S->bind_result($ID);

    $HTML = "<select name=\"" . $WidgetName . "\" >\n";

    $IsSelected = ($SelectedValue == 0) ? "SELECTED" : "";

    $HTML .= "<option value=\"0\" $IsSelected ></option>\n";

    while ($S->fetch()) {

      $Project->FindByID($ID);
      $IsSelected = ($SelectedValue == $Project->project_id) ? "SELECTED" : "";
      $HTML .= "<option value=\"" . $Project->project_id . "\" $IsSelected >" . $Project->project_name . "</option>\n";

    } // while

    $HTML .= "</select>\n";

    return $HTML;

  } // ProjectsSelection

  public function TicketStatusSelection ($WidgetName, $SelectedValue) {


    // You can get these values from $INSTALL/modules/ticketsmith/common.inc.php from the line beginning
    // $output = create_selectbox("type_toggle", array("Open" =>$AppUI->_("Open"), "Proce...
    // They DO NOT come from the Sysvals table.

    $Options = "Open|Open\nProcessing|Processing\nClosed|Closed\nDeleted|Deleted\nOn Hold|On Hold";

    $HTML = "<select name=\"" . $WidgetName . "\">\n";
    $HTML .= self::SysValToSelectionOption($Options, $SelectedValue);
    $HTML .= "</select>\n";

    return $HTML;

  } // TicketStatusSelection

  public function TicketPrioritySelection ($WidgetName, $SelectedValue) {

    $Sysvals = new clsSysvals ($this->DB);
    $Sysvals->FindByTitle("TicketPriority");

    $HTML = "<select name=\"" . $WidgetName . "\">\n";
    $HTML .= self::SysValToSelectionOption($Sysvals->sysval_value, $SelectedValue);
    $HTML .= "</select>\n";
    
    return $HTML;

  } // TicketPrioritySelection

  private function SysValToSelectionOption ($Values, $SelectedValue) {

    $Entries = explode ("\n", $Values);
    foreach ($Entries as $Entry) {

      $Entry = trim($Entry);
      $NVP = explode ("|", $Entry);

      $IsSelected = ($NVP[0] == $SelectedValue) ? "SELECTED" : "";
// echo "Comparing $NVP[0] to $SelectedValue IsSelected $IsSelected <br>";

      $HTML .= "<option value=\"" . $NVP[0] . "\" " . $IsSelected . " >" . $NVP[1] . "</option>\n";

    } // foreach

    return $HTML;

  } // SysVal2SelectionOption

} // class

?>