<?php

// $Id: clsProjects.php 13 2010-10-21 02:41:20Z scott_auge $

include_once ("clsUtil.php");

class clsProjects extends clsUtil {

	// Database object (usually clsDB.php)
	
	public $DB;
	
	// Database fields
	
	public $project_id;
	public $project_company;
	public $project_company_internal;
	public $project_department;
	public $project_name;
	public $project_short_name;
	public $project_owner;
	public $project_url;
	public $project_demo_url;
	public $project_start_date;
	public $project_end_date;
	public $project_actual_end_date;
	public $project_status;
	public $project_percent_complete;
	public $project_color_identifier;
	public $project_description;
	public $project_target_budget;
	public $project_actual_budget;
	public $project_creator;
	public $project_private;
	public $project_departments;
	public $project_contacts;
	public $project_priority;
	public $project_type;
		
	public function __construct ($DB) {
	
		$this->DB = $DB;
	
	} // Constructor
	
	public function Create () {
	
		$ID = self::RandomString(45);
		
		$SQL = "INSERT INTO projects (project_id) VALUES (?)";
		$S = $this->DB->Connection->prepare($SQL);
		$S->bind_param("s", $ID);
		$S->execute();
		$S->close();
		
		$this->project_id = $ID;
	
	} // Create ()
	
	public function Delete () {
	
		$SQL = "DELETE FROM projects WHERE project_id = ?";
		$S = $this->DB->Connection->prepare($SQL);
		$S->bind_param("s", $this->project_id);
		$S->execute();
		$S->close();	
	
	} // Delete ()
	
	
	public function Update () {

    //
    // We are using parameterized SQL, there is no need for magic quotes on this stuff.
    // If any of it is on, then we want to remove slashes from the input because it comes
    // back out with the slashes.
    //

    if (get_magic_quotes_gpc() || ini_get("magic_quotes_runtime")) {

      $this->project_id = stripslashes($this->project_id);
      $this->project_company = stripslashes($this->project_company);
      $this->project_company_internal = stripslashes($this->project_company_internal);
      $this->project_department = stripslashes($this->project_department);
      $this->project_name = stripslashes($this->project_name);
      $this->project_short_name = stripslashes($this->project_short_name);
      $this->project_owner = stripslashes($this->project_owner);
      $this->project_url = stripslashes($this->project_url);
      $this->project_demo_url = stripslashes($this->project_demo_url);
      $this->project_start_date = stripslashes($this->project_start_date);
      $this->project_end_date = stripslashes($this->project_end_date);
      $this->project_actual_end_date = stripslashes($this->project_actual_end_date);
      $this->project_status = stripslashes($this->project_status);
      $this->project_percent_complete = stripslashes($this->project_percent_complete);
      $this->project_color_identifier = stripslashes($this->project_color_identifier);
      $this->project_description = stripslashes($this->project_description);
      $this->project_target_budget = stripslashes($this->project_target_budget);
      $this->project_actual_budget = stripslashes($this->project_actual_budget);
      $this->project_creator = stripslashes($this->project_creator);
      $this->project_private = stripslashes($this->project_private);
      $this->project_departments = stripslashes($this->project_departments);
      $this->project_contacts = stripslashes($this->project_contacts);
      $this->project_priority = stripslashes($this->project_priority);
      $this->project_type = stripslashes($this->project_type);

    } // if magic used

	
		$SQL = "UPDATE projects SET project_id = ?,project_company = ?,project_company_internal = ?,project_department = ?,project_name = ?,project_short_name = ?,project_owner = ?,project_url = ?,project_demo_url = ?,project_start_date = ?,project_end_date = ?,project_actual_end_date = ?,project_status = ?,project_percent_complete = ?,project_color_identifier = ?,project_description = ?,project_target_budget = ?,project_actual_budget = ?,project_creator = ?,project_private = ?,project_departments = ?,project_contacts = ?,project_priority = ?,project_type = ? WHERE project_id = ?";
		$S = $this->DB->Connection->prepare($SQL);
		$S->bind_param("iiiississsssiissddiissiis", $this->project_id,$this->project_company,$this->project_company_internal,$this->project_department,$this->project_name,$this->project_short_name,$this->project_owner,$this->project_url,$this->project_demo_url,$this->project_start_date,$this->project_end_date,$this->project_actual_end_date,$this->project_status,$this->project_percent_complete,$this->project_color_identifier,$this->project_description,$this->project_target_budget,$this->project_actual_budget,$this->project_creator,$this->project_private,$this->project_departments,$this->project_contacts,$this->project_priority,$this->project_type,$this->project_id);
		$S->execute();
		$S->close();	
	
	} // Update ()

	
	public function FindByID ($ID) {
	
		$SQL = "SELECT project_id,project_company,project_company_internal,project_department,project_name,project_short_name,project_owner,project_url,project_demo_url,project_start_date,project_end_date,project_actual_end_date,project_status,project_percent_complete,project_color_identifier,project_description,project_target_budget,project_actual_budget,project_creator,project_private,project_departments,project_contacts,project_priority,project_type FROM projects WHERE project_id = ?";
		$S = $this->DB->Connection->prepare($SQL);
		$S->bind_param("s", $ID);
		$S->bind_result($this->project_id,$this->project_company,$this->project_company_internal,$this->project_department,$this->project_name,$this->project_short_name,$this->project_owner,$this->project_url,$this->project_demo_url,$this->project_start_date,$this->project_end_date,$this->project_actual_end_date,$this->project_status,$this->project_percent_complete,$this->project_color_identifier,$this->project_description,$this->project_target_budget,$this->project_actual_budget,$this->project_creator,$this->project_private,$this->project_departments,$this->project_contacts,$this->project_priority,$this->project_type);
		$S->execute();
		$S->fetch();
		$S->close();
	
	} // FindByID ()

} // class


?>