<?php
//
// Generated by tools/TableClass.php
//

include_once ("clsUtil.php");

class clsSession extends clsUtil {

  // Database object (usually clsDB.php)

  public $DB;

  // Database fields

  public $session_id;
  public $session_user;
  public $session_data;
  public $session_updated;
  public $session_created;

  public function __construct ($DB) {

    $this->DB = $DB;

  } // Constructor

  public function Create ($ID) { // manual change

    $SQL = "INSERT INTO sessions (session_id) VALUES (?)";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("s", $ID);
    $S->execute();
    $S->close();
    $this->session_id = $ID;

  } // Create ()

  public function Delete () {

    $SQL = "DELETE FROM sessions WHERE session_id = ?";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("s", $this->session_id);
    $S->execute();
    $S->close();

  } // Delete ()


  public function Update () {

    //
    //  Warning!  Generator doesn't handle blob fields very well.  You may need to do some
    //            hand coding with MySQLi's Stmt->send_long_data() to properly update.  If
    //            the blob exceeds MYSQLs packet size (the DB, not PHP) then corruption is
    //            guaranteed.
    //            Use
    //                mysql> SHOW VARIABLES LIKE 'max_allowed_packet';
    //            to determine the size of data you're set up for.
    //

    // Begin manual change
    $SQL = "UPDATE sessions SET session_user = ?,session_updated = NOW() WHERE session_id = ?";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("is",$this->session_user,$this->session_id);
    $S->execute();
    $S->close();

    $Null = NULL;
    $SQL = "UPDATE sessions SET session_data = ? WHERE session_id = ?";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("bs", $Null,$this->session_id);
    $S->send_long_data(0,$this->session_data);
    $S->execute();
    $S->close();
    // End manual change
    
  } // Update ()


  public function FindByID ($ID) {

    $SQL = "SELECT session_id,session_user,session_data,session_updated,session_created FROM sessions WHERE session_id = ?";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("s", $ID);

    // This order is very important for dealing with BLOBs and other large data types

    $S->execute();
    $S->store_result();
    $S->bind_result($this->session_id,$this->session_user,$this->session_data,$this->session_updated,$this->session_created);
    
    $S->fetch();
    $S->close();

  } // FindByID ()

} // class



/* UNIT Test Code 

include_once ("clsDB.php");

$DB = new clsDB();
$S = new clsSession ($DB);
$S->FindByID ("1286746945BuufKh7NYxPzLe9RdlWcW3C42l5Jg2");
echo $S->session_data;

//$S->Create();
//echo $S->session_id . "<br>";
$S->session_data = serialize(array ("UserName" => "Scott"));

$S->Update();

 */
?>