<?php

//
// Generated by tools/TableClass.php
// on Sunday, 10-Oct-10 22:02:34 EDT
// $Id: clsTicket.php 25 2010-10-22 08:14:40Z scott_auge $
//

/**************************************************************************/
/*                              PLEASE READ                               */
/*                                ______                                  */
/*                             .-"      "-.                               */
/*                            /            \                              */
/*                _          |              |          _                  */
/*               ( \         |,  .-.  .-.  ,|         / )                 */
/*                > "=._     | )(__/  \__)( |     _.=" <                  */
/*               (_/"=._"=._ |/     /\     \| _.="_.="\_)                 */
/*                      "=._ (_     ^^     _)"_.="                        */
/*                          "=\__|IIIIII|__/="                            */
/*                         _.="| \IIIIII/ |"=._                           */
/*               _     _.="_.="\          /"=._"=._     _                 */
/*              ( \_.="_.="     `--------`     "=._"=._/ )                */
/*               > _.="                            "=._ <                 */
/*              (_/                                    \_)                */
/**************************************************************************/
/* Manual update on Create(), Update(), and Delete()                      */
/**************************************************************************/



include_once ("clsUtil.php");

class clsTicket extends clsUtil {

  // Database object (usually clsDB.php)

  public $DB;

  // Database fields

    public $ticket;
    public $ticket_company;
    public $ticket_project;
    public $author;
    public $recipient;
    public $subject;
    public $attachment;
    public $timestamp;
    public $type;
    public $assignment;
    public $parent;
    public $activity;
    public $priority;
    public $cc;
    public $body;
    public $signature;

  public function __construct ($DB) {

    $this->DB = $DB;

  } // Constructor

  public function Create () {


    // if an auto incrementing key field, then we need to use last_insert_id() to get the value
    // last_insert_id() is mysql oriented.  See curval() for postgresql

    $SQL = "INSERT INTO tickets (timestamp) VALUES (UNIX_TIMESTAMP())";
    $S = $this->DB->Connection->prepare($SQL);
    $S->execute();

    $SQL = "SELECT LAST_INSERT_ID();";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_result($ID);
    $S->execute();
    $S->fetch();

    $S->close();

    $this->ticket = $ID;

    // Load up our defaults into the "buffer"
    
    $this->FindByID($ID);

  } // Create ()

  public function Delete () {

    //
    // Notes are stored in the tickets table
    //

    $SQL = "DELETE FROM tickets WHERE parent = ?";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("s", $this->ticket);
    $S->execute();
    $S->close();
    
    //
    // Deleting the ticket 
    //

    $SQL = "DELETE FROM tickets WHERE ticket = ?";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("s", $this->ticket);
    $S->execute();
    $S->close();

  } // Delete ()


  public function Update () {

    //
    // We are using parameterized SQL, there is no need for magic quotes on this stuff.
    // If any of it is on, then we want to remove slashes from the input because it comes
    // back out with the slashes.
    //

    if (get_magic_quotes_gpc() || ini_get("magic_quotes_runtime")) {

      $this->ticket = stripslashes($this->ticket);
      $this->ticket_company = stripslashes($this->ticket_company);
      $this->ticket_project = stripslashes($this->ticket_project);
      $this->author = stripslashes($this->author);
      $this->recipient = stripslashes($this->recipient);
      $this->subject = stripslashes($this->subject);
      $this->attachment = stripslashes($this->attachment);
      $this->timestamp = stripslashes($this->timestamp);
      $this->type = stripslashes($this->type);
      $this->assignment = stripslashes($this->assignment);
      $this->parent = stripslashes($this->parent);
      $this->activity = stripslashes($this->activity);
      $this->priority = stripslashes($this->priority);
      $this->cc = stripslashes($this->cc);
      $this->body = stripslashes($this->body);
      $this->signature = stripslashes($this->signature);

    } // if magic used


    //
    //  Warning!  Generator doesn't handle blob fields very well.  You may need to do some
    //            hand coding with MySQLi's Stmt->send_long_data() to properly update.  If
    //            the blob exceeds MYSQLs packet size (the DB, not PHP) then corruption is
    //            guaranteed.
    //            Use
    //                mysql> SHOW VARIABLES LIKE 'max_allowed_packet';
    //            to determine the size of data you're set up for.
    //

    $SQL = "UPDATE tickets SET ticket_company = ?,ticket_project = ?,author = ?,recipient = ?,subject = ?,attachment = ?,timestamp = ?,type = ?,assignment = ?,parent = ?,activity = ?,priority = ?,cc = ?,body = ?,signature = ? WHERE ticket = ?";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("iisssiisiiiisssi", $this->ticket_company,$this->ticket_project, $this->author ,$this->recipient,$this->subject,$this->attachment,$this->timestamp,$this->type,$this->assignment,$this->parent,$this->activity,$this->priority,$this->cc,$this->body,$this->signature,$this->ticket);
    $S->execute();
    $S->close();

    //
    //  For some reason author is not updating in the above SQL.  So simply do it here I guess.
    //

    $SQL = "UPDATE tickets SET author = ? WHERE ticket = ?";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("ss", $this->author ,$this->ticket);
    $S->execute();
    $S->close();

  } // Update ()


  public function FindByID ($ID) {

    $SQL = "SELECT ticket,ticket_company,ticket_project,author,recipient,subject,attachment,timestamp,type,assignment,parent,activity,priority,cc,body,signature FROM tickets WHERE ticket = ?";
    $S = $this->DB->Connection->prepare($SQL);
    $S->bind_param("s", $ID);

    // This order is very important for dealing with BLOBs and other large data types

    $S->execute();
    $S->store_result();
    $S->bind_result($this->ticket,$this->ticket_company,$this->ticket_project,$this->author,$this->recipient,$this->subject,$this->attachment,$this->timestamp,$this->type,$this->assignment,$this->parent,$this->activity,$this->priority,$this->cc,$this->body,$this->signature);

    $S->fetch();
    $S->close();

  } // FindByID ()

} // class



/* UNIT TEST CODE

include ("clsDB.php");

$DB = new clsDB();
$T = new clsTicket($DB);
$T->Create();
echo $T->ticket;
*/
?>


